/* ZIPShellExt.cpp : Legt die Initialisierungsroutinen fr die DLL fest.*/

#define STRICT
#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <limits.h>

#include "unzip32dll.h"
#pragma data_seg(".text")
#include <objbase.h>
#include <initguid.h>
#include <shlobj.h>
#include "ClassFactory.h"
#include "ZIPShellExt.h"
#include "Dialog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern "C"
{
USERFUNCTIONS    UserFunctions;
HINSTANCE        g_hInst;
HINSTANCE        hUnzip32Dll;
_DLL_UNZIP       windll_unzip;
_DLL_VERSION     lUzpVersion;   /* UzpVersion already defined in unzip.h as a funktion */
ZIPMessage       *Messages;
ZIPEntry         *Entries;
UzpVer           UnzipVersion;
}
extern    LONG        g_cRef;
/*
//    Beachten Sie!
//
//        Wird diese DLL dynamisch an die MFC-DLLs gebunden,
//        muss bei allen von dieser DLL exportierten Funktionen,
//        die MFC-Aufrufe durchfhren, das Makro AFX_MANAGE_STATE
//        direkt am Beginn der Funktion eingefgt sein.
//
//        Beispiel:
//
//        extern "C" BOOL PASCAL EXPORT ExportedFunction()
//        {
//            AFX_MANAGE_STATE(AfxGetStaticModuleState());
//        // Hier normaler Funktionsrumpf
//        }
//
//        Es ist sehr wichtig, dass dieses Makro in jeder Funktion
//        vor allen MFC-Aufrufen erscheint. Dies bedeutet, dass es
//        als erste Anweisung innerhalb der Funktion ausgefhrt werden
//        muss, sogar vor jeglichen Deklarationen von Objektvariablen,
//        da ihre Konstruktoren Aufrufe in die MFC-DLL generieren
//        knnten.
//
//        Siehe MFC Technical Notes 33 und 58 fr weitere
//        Details.
//

// -------------------------------------------------------------
// General DLL functions
// -------------------------------------------------------------
// Main DLL entry point - stash the module instance handle for use
// later, return TRUE in all cases.*/
extern "C" int APIENTRY
DllMain( HANDLE hInst, ULONG uReason, LPVOID pRes )
{
    if( uReason == DLL_PROCESS_ATTACH )
        g_hInst = (HINSTANCE)hInst;

    return TRUE;
}

/*
// Every InProc server must support DllGetClassObject. The only
// object supported by this server is CLSID_ZIPExtension, all 
// other requests are rejected. For our extension, a ClassFactory
// object is created, and a QIF is performed for the requested
// interface through the ClassFactory.*/
STDAPI DllGetClassObject(REFCLSID rcid, REFIID riid, LPVOID *ppv)
{
    HRESULT hr;
    *ppv = NULL; // Always clear the "out" parameter
    if( IsEqualCLSID( rcid, CLSID_ZIPExtension ) == FALSE )
        hr = ResultFromScode( CLASS_E_CLASSNOTAVAILABLE );
    else
    {
        CClassFactory* pFactory = new CClassFactory;
        if( pFactory == NULL )
            hr = ResultFromScode( E_OUTOFMEMORY );
        else
        {
            hr = pFactory->QueryInterface( riid, ppv );
        }
    }
    return hr;
}
//
// DllCanUnloadNow is called by the OS to determine if the inproc
// server can be unloaded. If the global reference count is greater
// than zero, S_FALSE is returned to prevent unloading.
STDAPI DllCanUnloadNow()
{
    HRESULT hr = S_FALSE;
    if( g_cRef == 0 )
        hr = S_OK;
    return hr;
}

/*///////////////////////////////////////////////////////////////////////////
// CZIPShellExtApp

BEGIN_MESSAGE_MAP(CZIPShellExtApp, CWinApp)
    //{{AFX_MSG_MAP(CZIPShellExtApp)
        // HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
        //    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZIPShellExtApp Konstruktion

CZIPShellExtApp::CZIPShellExtApp()
{
    // ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
    // Alle wichtigen Initialisierungen in InitInstance platzieren
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CZIPShellExtApp-Objekt

CZIPShellExtApp theApp;

//////////////////////////////////////////////////////////////////////
// CZIPShellExt Klasse
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
////////////////////////////////////////////////////////////////////*/

CZIPShellExt::CZIPShellExt()
{
    Messages=NULL;
    Entries=NULL;
    DCLBlock.lpszZipFN=NULL;
}

CZIPShellExt::~CZIPShellExt()
{   ZIPMessage    *ptr3a=Messages,*ptr3b;
    ZIPEntry    *ptr2a=Entries,*ptr2b;

    while(ptr3a!=NULL)
    {   ptr3b=ptr3a->Next;
        delete ptr3a;
        ptr3a=ptr3b;
    }

    while(ptr2a!=NULL)
    {   ptr2b=ptr2a->Next;
        delete ptr2a;
        ptr2a=ptr2b;
    }

    if(DCLBlock.lpszZipFN)
        free(DCLBlock.lpszZipFN);

}

// IUnknown interfaces for the Shell Interfaces
STDMETHODIMP CZIPShellExt::QueryInterface( REFIID riid, LPVOID* ppv )
{
    if( IsEqualIID( riid, IID_IUnknown ) == TRUE )
    {
        *ppv = (LPUNKNOWN)(LPCONTEXTMENU)this;
        m_cRef++;
        return NOERROR;
    }
    else if( IsEqualIID( riid, IID_IContextMenu ) == TRUE )
    {
        *ppv = (LPCONTEXTMENU)this;
        m_cRef++;
        return NOERROR;
    }
    else if(IsEqualIID(riid,IID_IShellPropSheetExt))
    {
        *ppv=(LPSHELLPROPSHEETEXT)this;
        m_cRef++;
        return NOERROR;
    }
    else if( IsEqualIID( riid, IID_IShellExtInit ) == TRUE )
    {
        *ppv = (LPSHELLEXTINIT)this;
        m_cRef++;
        return NOERROR;
    }
    else
    {
        *ppv = NULL;
        return ResultFromScode( E_NOINTERFACE );
    }
}
STDMETHODIMP_(ULONG) CZIPShellExt::AddRef()
{
    return ++m_cRef;
}
STDMETHODIMP_(ULONG) CZIPShellExt::Release()
{
    if (--m_cRef)
        return m_cRef;
    delete this;
    return 0L;
}

// -------------------------------------------------------------
// IShellExtInit interface
// -------------------------------------------------------------
// IShellExtInit only has one function - Initialize is called to
// prepare your shell extension for calls that will be made on
// other interfaces - in this case, through IContextMenu. The main
// point of interest for a context menu is the name of the file
// object receiving the mouse-click, which is collected using
// DragQueryFile. 
STDMETHODIMP CZIPShellExt::Initialize(LPCITEMIDLIST pidl,LPDATAOBJECT pObj,HKEY hKeyProgID)
{   STGMEDIUM   stg;
    FORMATETC   fetc = { CF_HDROP,NULL,DVASPECT_CONTENT,-1,TYMED_HGLOBAL };

    if( pObj == NULL )
        return ResultFromScode( E_FAIL );

    HRESULT hr = pObj->GetData( &fetc, &stg );
    if( FAILED(hr) )
        return ResultFromScode( E_FAIL );

    UINT cFiles = DragQueryFile((HDROP)stg.hGlobal,0xFFFFFFFF,NULL,0);
    if( cFiles == 1 )
    {
        memset(&DCLBlock,0,sizeof(DCL));
        if(!DCLBlock.lpszZipFN)
            DCLBlock.lpszZipFN=(char*)malloc((MAX_PATH+1)*sizeof(char));

        DragQueryFile((HDROP)stg.hGlobal,0,DCLBlock.lpszZipFN,MAX_PATH+1);

        UserFunctions.print=&ZIPPrint;
        UserFunctions.sound=NULL;
        UserFunctions.replace=&GetReplaceDlgRetVal;
        UserFunctions.password=&GetPasswd;
        UserFunctions.SendApplicationMessage=&ReceiveDllMessage;

        hr = NOERROR;
    }
    else
        hr = ResultFromScode( E_FAIL );

    ReleaseStgMedium( &stg );
    return hr;
}
// -------------------------------------------------------------
// IContextMenu interfaces
// -------------------------------------------------------------
//
// QueryContextMenu is called when the shell requests the extension
// to add its menu items to the context menu. It's possible to get
// a NULL menu handle here. Also note that the current (As of this
// writing) Win32 SDK documentation is wrong regarding the nFlags
// parameter. This function should always return the number of new
// items added to the menu.
STDMETHODIMP CZIPShellExt::QueryContextMenu(HMENU hMenu,UINT nMenuIndex,UINT nFirstID,UINT nLastID,UINT nFlags)
{   char szMenu[32];
    BOOL fAppend = FALSE;
 
    if( (nFlags & 0x000F) == CMF_NORMAL)
    {
        fAppend = TRUE;
    }
    else if(nFlags & CMF_VERBSONLY)
    {
        fAppend = TRUE;
    }
    else if(nFlags & CMF_EXPLORE)
    {
        fAppend = TRUE;
    }
    if(fAppend && hMenu)
    {
        LoadString(g_hInst,IDS_MENU_TEST,szMenu,sizeof(szMenu));
        BOOL f = ::InsertMenu(hMenu,nMenuIndex,MF_STRING|MF_BYPOSITION,nFirstID,szMenu);
        return ResultFromScode( MAKE_SCODE(SEVERITY_SUCCESS,0,USHORT(1)) );
    }
    return NOERROR;
    
}
//
// InvokeCommand is the "Money Shot". This is a notification that
// the user has clicked on one of the selected items in the context
// menu. The name of the file is not passed to you in this function
// since it was passed in the IShellExtInit::Initialize  function.
STDMETHODIMP CZIPShellExt::InvokeCommand(LPCMINVOKECOMMANDINFO pInfo)
{//    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    char        buffer[52],
                format[52],*pFile;
        
    if( HIWORD(pInfo->lpVerb) != 0 )
        return ResultFromScode( E_FAIL );

    if( LOWORD(pInfo->lpVerb) > OFFSET_COUNTLINES )
        return ResultFromScode( E_INVALIDARG );

    if( LOWORD(pInfo->lpVerb) == OFFSET_COUNTLINES )
    {
        if(!GetUnzipDll())
            return E_FAIL;

        UnzipVersion= *lUzpVersion();

        ZIPMessage  *ptr,
                    *ptr1=Messages;    //save original list
        BOOL        Error=FALSE;

        pFile=DCLBlock.lpszZipFN;
        memset(&DCLBlock,0,sizeof(DCL));
        DCLBlock.ntflag=TRUE;
        DCLBlock.lpszZipFN=pFile;
//        DCLBlock.lpszZipFN=theApp.m_szFile;
//        memset(&UserFunctions,0,sizeof(USERFUNCTIONS));
/*        UserFunctions.print=&ZIPPrint;
        UserFunctions.sound=NULL;
        UserFunctions.replace=&GetReplaceDlgRetVal;
        UserFunctions.password=&GetPasswd;
        UserFunctions.SendApplicationMessage=&ReceiveDllMessage;*/
        windll_unzip(0,NULL,&DCLBlock,&UserFunctions);
        ptr=Messages;    //get new list    
        Messages=ptr1;    //restore original list
//        CString    string;
        while(ptr)
        {   if(strstr(ptr->string,"testing"))
            {   if(!strstr(ptr->Next->string,"OK"))
                {   LoadString(g_hInst,IDS_ERROR_MSG1,format,sizeof(format));
                    sprintf(buffer,format,DCLBlock.lpszZipFN,ptr->Next->string);
                    MessageBox(NULL,buffer,"Error",MB_ICONERROR|MB_OK);
                    Error=TRUE;
                }
            }
            ptr1=ptr->Next;
            delete ptr;
            ptr=ptr1;
        }
        
        if(!Error)
        {   LoadString(g_hInst,IDS_ERROR_MSG2,format,sizeof(format));
            sprintf(buffer,format,DCLBlock.lpszZipFN);
            MessageBox(NULL,buffer,"No Error",MB_ICONINFORMATION|MB_OK);
        }

//        FreeLibrary(hUnzip32Dll);
    }

    return NOERROR;
}
//
// GetCommandString is called by the shell to retrieve a string
// associated with a new menu item.
STDMETHODIMP CZIPShellExt::GetCommandString(UINT nItemID,UINT nFlags,UINT* pReserved,LPSTR pszName,UINT cchMax)
{
    if( nItemID == OFFSET_COUNTLINES )
    {
        switch( nFlags )
        {   case GCS_HELPTEXT:
                LoadString(g_hInst,IDS_HELPTEXT,pszName,cchMax);
                return NOERROR;
            break;
            case GCS_VALIDATE:
                return NOERROR;
            break;
            case GCS_VERB:
                LoadString(g_hInst,IDS_VERB,pszName,cchMax);
            break;
        }
    }
    return ResultFromScode(E_INVALIDARG);
}

//
// IShellPropSheetExt
STDMETHODIMP CZIPShellExt::AddPages(LPFNADDPROPSHEETPAGE lpfnAddPage,LPARAM lParam)
{   PROPSHEETPAGE    PropPage;
    HPROPSHEETPAGE    hPropPage;

    memset(&PropPage,0,sizeof(PropPage));

    PropPage.dwSize=sizeof(PROPSHEETPAGE);
    PropPage.dwFlags=PSP_USECALLBACK;
    PropPage.hInstance=g_hInst;
    PropPage.pszTemplate=MAKEINTRESOURCE(IDD_ZIPSHELL_DIALOG);
    PropPage.lParam=(long)malloc(sizeof(ZIPShellDlgData));
    memset((void*)PropPage.lParam,0,sizeof(ZIPShellDlgData));
    PropPage.pfnDlgProc=PropDlgProc;
    PropPage.pfnCallback=PropPageCallback;
    hPropPage=CreatePropertySheetPage(&PropPage);

    ((ZIPShellDlgData*)PropPage.lParam)->DCLBlock=DCLBlock;
    // maybe a registryentry in the next version
    ((ZIPShellDlgData*)PropPage.lParam)->ColFlags=COL_SIZE|COL_CSIZE;
//LPFNPSPCALLBACK
//DLGPROC
    lpfnAddPage(hPropPage,lParam);
    return(NOERROR);
}

STDMETHODIMP CZIPShellExt::ReplacePage(UINT uPageID,LPFNADDPROPSHEETPAGE lpfnReplacePage,LPARAM lParam)
{
    return(NOERROR);
}

BOOL GetUnzipDll()
{   char        buffer[64];

    if(!hUnzip32Dll)
    {   hUnzip32Dll=LoadLibrary(UNZ_DLL_NAME);
        windll_unzip=NULL;
        lUzpVersion=NULL;
    }

    if(!hUnzip32Dll)
    {   LoadString(g_hInst,IDS_ERROR_MSG3,buffer,sizeof(buffer));
        MessageBox(NULL,buffer,"Error",MB_ICONERROR|MB_OK);
        return FALSE;
    }
     
    if(!windll_unzip)
        windll_unzip=(_DLL_UNZIP)GetProcAddress(hUnzip32Dll,"windll_unzip");

    if(!lUzpVersion)
        lUzpVersion=(_DLL_VERSION)GetProcAddress(hUnzip32Dll,"UzpVersion");

    if(!windll_unzip || !lUzpVersion)
    {   LoadString(g_hInst,IDS_ERROR_MSG4,buffer,sizeof(buffer));
        MessageBox(NULL,buffer,"Error",MB_ICONERROR|MB_OK);
        return FALSE;
    }

    return TRUE;
}